coreEngine.Calibration

## Class Algorithm

- java.lang.Object
- - coreEngine.Calibration.Algorithm

- Direct Known Subclasses:
    Metaheuristic

      public abstract class Algorithm
      extends java.lang.Object

  Author:
    jltrask

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private float` | `AF_MIN`
    `private int` | `AF_RANGE`
    `private float` | `AF_STEP`
    `private float` | `CDP_MIN`
    `private int` | `CDP_RANGE`
    `private float` | `CDP_STEP`
    `static int` | `DEFAULT_AF_RANGE`
    `static float` | `DEFAULT_AF_STEP`
    `static float` | `DEFAULT_CDP_MIN`
    `static int` | `DEFAULT_CDP_RANGE`
    `static float` | `DEFAULT_CDP_STEP`
    `static float` | `DEFAULT_JD_MIN`
    `static int` | `DEFAULT_JD_RANGE`
    `static float` | `DEFAULT_JD_STEP`
    `static int` | `DEFAULT_MAX_ITERATIONS`
    `static float` | `DEFUALT_AF_MIN`
    `protected boolean` | `isAdaptive`
    `protected boolean` | `isMemetic`
    `private float` | `JD_MIN`
    `private int` | `JD_RANGE`
    `private float` | `JD_STEP`
    `protected int` | `MAX_ITER` Maximum number of iterations to run
    `protected java.lang.String` | `name`
    `protected int` | `numIter`
    `protected int` | `numParallelSeeds`
    `protected float` | `optimalTol`
    `StatisticsHelper` | `stats`
    `protected boolean` | `useParallel`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Algorithm()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `float` | `getAF_MAX()`
    `float` | `getAF_MIN()`
    `int` | `getAF_RANGE()`
    `float` | `getAF_STEP()`
    `abstract Organism` | `getBestOrganism()` Returns the best organism that has been found.
    `float` | `getCDP_MAX()`
    `float` | `getCDP_MIN()`
    `int` | `getCDP_RANGE()`
    `float` | `getCDP_STEP()`
    `float` | `getJD_MAX()`
    `float` | `getJD_MIN()`
    `int` | `getJD_RANGE()`
    `float` | `getJD_STEP()`
    `int` | `getMAX_ITER()`
    `int` | `getNumParallelSeeds()`
    `float` | `getOptimalTol()`
    `abstract Seed` | `getSolnSeed()` Returns the Seed file with the best found solution applied to it.
    `abstract void` | `initialize(AlgHelper fh, Seed[] seed)` Initializes the algorithm
    `abstract void` | `initialize(Seed targetSeed, Seed[] seed)` Initializes the algorithm
    `boolean` | `isAdaptive()`
    `boolean` | `isMemetic()`
    `boolean` | `isUseParallel()`
    `void` | `setAdaptive(boolean isAdaptive)`
    `void` | `setAF_MIN(float AF_MIN)`
    `void` | `setAF_RANGE(int AF_RANGE)`
    `void` | `setAF_STEP(float AF_STEP)`
    `void` | `setCDP_MIN(float CDP_MIN)`
    `void` | `setCDP_RANGE(int CDP_RANGE)`
    `void` | `setCDP_STEP(float CDP_STEP)`
    `void` | `setJD_MIN(float JD_MIN)`
    `void` | `setJD_RANGE(int JD_RANGE)`
    `void` | `setJD_STEP(float JD_STEP)`
    `void` | `setMAX_ITER(int MAX_ITER)`
    `void` | `setMemetic(boolean isMemetic)`
    `void` | `setName(java.lang.String newName)`
    `void` | `setNumParallelSeeds(int numParallelSeeds)`
    `void` | `setOptimalTol(float optimalTol)`
    `void` | `setUseParallel(boolean useParallel)`
    `abstract void` | `solveInstance()` Runs the algorithm
    `abstract void` | `solveInstance(PopupLog logger)` Runs the algorithm with a logger to display the progress
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_MAX_ITERATIONS

          public static final int DEFAULT_MAX_ITERATIONS

      See Also:
        Constant Field Values

    - #### DEFUALT_AF_MIN

          public static final float DEFUALT_AF_MIN

      See Also:
        Constant Field Values

    - #### DEFAULT_AF_RANGE

          public static final int DEFAULT_AF_RANGE

      See Also:
        Constant Field Values

    - #### DEFAULT_AF_STEP

          public static final float DEFAULT_AF_STEP

      See Also:
        Constant Field Values

    - #### AF_RANGE

          private int AF_RANGE

    - #### AF_MIN

          private float AF_MIN

    - #### AF_STEP

          private float AF_STEP

    - #### DEFAULT_CDP_MIN

          public static final float DEFAULT_CDP_MIN

      See Also:
        Constant Field Values

    - #### DEFAULT_CDP_RANGE

          public static final int DEFAULT_CDP_RANGE

      See Also:
        Constant Field Values

    - #### DEFAULT_CDP_STEP

          public static final float DEFAULT_CDP_STEP

      See Also:
        Constant Field Values

    - #### CDP_MIN

          private float CDP_MIN

    - #### CDP_RANGE

          private int CDP_RANGE

    - #### CDP_STEP

          private float CDP_STEP

    - #### DEFAULT_JD_MIN

          public static final float DEFAULT_JD_MIN

      See Also:
        Constant Field Values

    - #### DEFAULT_JD_RANGE

          public static final int DEFAULT_JD_RANGE

      See Also:
        Constant Field Values

    - #### DEFAULT_JD_STEP

          public static final float DEFAULT_JD_STEP

      See Also:
        Constant Field Values

    - #### JD_MIN

          private float JD_MIN

    - #### JD_RANGE

          private int JD_RANGE

    - #### JD_STEP

          private float JD_STEP

    - #### name

          protected java.lang.String name

    - #### optimalTol

          protected float optimalTol

    - #### numIter

          protected int numIter

    - #### useParallel

          protected boolean useParallel

    - #### isAdaptive

          protected boolean isAdaptive

    - #### isMemetic

          protected boolean isMemetic

    - #### numParallelSeeds

          protected int numParallelSeeds

    - #### stats

          public StatisticsHelper stats

    - #### MAX_ITER

          protected int MAX_ITER

      Maximum number of iterations to run

  - ### Constructor Detail

    - #### Algorithm

          public Algorithm()

  - ### Method Detail

    - #### initialize

          public abstract void initialize(Seed targetSeed,
                                          Seed[] seed)

      Initializes the algorithm
      Parameters:
        `targetSeed` -
        `seed` -

    - #### initialize

          public abstract void initialize(AlgHelper fh,
                                          Seed[] seed)

      Initializes the algorithm
      Parameters:
        `fh` -
        `seed` -

    - #### solveInstance

          public abstract void solveInstance()

      Runs the algorithm

    - #### getBestOrganism

          public abstract Organism getBestOrganism()

      Returns the best organism that has been found.
      Returns:

    - #### getSolnSeed

          public abstract Seed getSolnSeed()

      Returns the Seed file with the best found solution applied to it.
      Returns:

    - #### solveInstance

          public abstract void solveInstance(PopupLog logger)

      Runs the algorithm with a logger to display the progress
      Parameters:
        `logger` -

    - #### setName

          public void setName(java.lang.String newName)

    - #### getOptimalTol

          public float getOptimalTol()

    - #### setOptimalTol

          public void setOptimalTol(float optimalTol)

    - #### getMAX_ITER

          public int getMAX_ITER()

    - #### setMAX_ITER

          public void setMAX_ITER(int MAX_ITER)

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### isUseParallel

          public boolean isUseParallel()

    - #### isAdaptive

          public boolean isAdaptive()

    - #### setAdaptive

          public void setAdaptive(boolean isAdaptive)

    - #### isMemetic

          public boolean isMemetic()

    - #### setMemetic

          public void setMemetic(boolean isMemetic)

    - #### getNumParallelSeeds

          public int getNumParallelSeeds()

    - #### setUseParallel

          public void setUseParallel(boolean useParallel)

    - #### setNumParallelSeeds

          public void setNumParallelSeeds(int numParallelSeeds)

    - #### getAF_RANGE

          public int getAF_RANGE()

    - #### setAF_RANGE

          public void setAF_RANGE(int AF_RANGE)

    - #### getAF_MIN

          public float getAF_MIN()

    - #### setAF_MIN

          public void setAF_MIN(float AF_MIN)

    - #### getAF_STEP

          public float getAF_STEP()

    - #### setAF_STEP

          public void setAF_STEP(float AF_STEP)

    - #### getAF_MAX

          public float getAF_MAX()

    - #### getCDP_MIN

          public float getCDP_MIN()

    - #### setCDP_MIN

          public void setCDP_MIN(float CDP_MIN)

    - #### getCDP_RANGE

          public int getCDP_RANGE()

    - #### setCDP_RANGE

          public void setCDP_RANGE(int CDP_RANGE)

    - #### getCDP_STEP

          public float getCDP_STEP()

    - #### setCDP_STEP

          public void setCDP_STEP(float CDP_STEP)

    - #### getCDP_MAX

          public float getCDP_MAX()

    - #### getJD_MIN

          public float getJD_MIN()

    - #### setJD_MIN

          public void setJD_MIN(float JD_MIN)

    - #### getJD_RANGE

          public int getJD_RANGE()

    - #### setJD_RANGE

          public void setJD_RANGE(int JD_RANGE)

    - #### getJD_STEP

          public float getJD_STEP()

    - #### setJD_STEP

          public void setJD_STEP(float JD_STEP)

    - #### getJD_MAX

          public float getJD_MAX()